# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = [
    'GetAttachedNetworkResult',
    'AwaitableGetAttachedNetworkResult',
    'get_attached_network',
    'get_attached_network_output',
]

@pulumi.output_type
class GetAttachedNetworkResult:
    """
    A collection of values returned by getAttachedNetwork.
    """
    def __init__(__self__, dev_center_id=None, id=None, name=None, network_connection_id=None):
        if dev_center_id and not isinstance(dev_center_id, str):
            raise TypeError("Expected argument 'dev_center_id' to be a str")
        pulumi.set(__self__, "dev_center_id", dev_center_id)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if network_connection_id and not isinstance(network_connection_id, str):
            raise TypeError("Expected argument 'network_connection_id' to be a str")
        pulumi.set(__self__, "network_connection_id", network_connection_id)

    @property
    @pulumi.getter(name="devCenterId")
    def dev_center_id(self) -> builtins.str:
        return pulumi.get(self, "dev_center_id")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> builtins.str:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="networkConnectionId")
    def network_connection_id(self) -> builtins.str:
        """
        The ID of the attached Dev Center Network Connection.
        """
        return pulumi.get(self, "network_connection_id")


class AwaitableGetAttachedNetworkResult(GetAttachedNetworkResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetAttachedNetworkResult(
            dev_center_id=self.dev_center_id,
            id=self.id,
            name=self.name,
            network_connection_id=self.network_connection_id)


def get_attached_network(dev_center_id: Optional[builtins.str] = None,
                         name: Optional[builtins.str] = None,
                         opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetAttachedNetworkResult:
    """
    Use this data source to access information about an existing Dev Center Attached Network.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_azure as azure

    example = azure.devcenter.get_attached_network(name=example_azurerm_dev_center_attached_network["name"],
        dev_center_id=example_azurerm_dev_center_attached_network["devCenterId"])
    pulumi.export("id", example.id)
    ```

    ## API Providers

    <!-- This section is generated, changes will be overwritten -->
    This data source uses the following Azure API Providers:

    * `Microsoft.DevCenter`: 2025-02-01


    :param builtins.str dev_center_id: The ID of the associated Dev Center.
    :param builtins.str name: The name of this Dev Center Attached Network.
    """
    __args__ = dict()
    __args__['devCenterId'] = dev_center_id
    __args__['name'] = name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure:devcenter/getAttachedNetwork:getAttachedNetwork', __args__, opts=opts, typ=GetAttachedNetworkResult).value

    return AwaitableGetAttachedNetworkResult(
        dev_center_id=pulumi.get(__ret__, 'dev_center_id'),
        id=pulumi.get(__ret__, 'id'),
        name=pulumi.get(__ret__, 'name'),
        network_connection_id=pulumi.get(__ret__, 'network_connection_id'))
def get_attached_network_output(dev_center_id: Optional[pulumi.Input[builtins.str]] = None,
                                name: Optional[pulumi.Input[builtins.str]] = None,
                                opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetAttachedNetworkResult]:
    """
    Use this data source to access information about an existing Dev Center Attached Network.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_azure as azure

    example = azure.devcenter.get_attached_network(name=example_azurerm_dev_center_attached_network["name"],
        dev_center_id=example_azurerm_dev_center_attached_network["devCenterId"])
    pulumi.export("id", example.id)
    ```

    ## API Providers

    <!-- This section is generated, changes will be overwritten -->
    This data source uses the following Azure API Providers:

    * `Microsoft.DevCenter`: 2025-02-01


    :param builtins.str dev_center_id: The ID of the associated Dev Center.
    :param builtins.str name: The name of this Dev Center Attached Network.
    """
    __args__ = dict()
    __args__['devCenterId'] = dev_center_id
    __args__['name'] = name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure:devcenter/getAttachedNetwork:getAttachedNetwork', __args__, opts=opts, typ=GetAttachedNetworkResult)
    return __ret__.apply(lambda __response__: GetAttachedNetworkResult(
        dev_center_id=pulumi.get(__response__, 'dev_center_id'),
        id=pulumi.get(__response__, 'id'),
        name=pulumi.get(__response__, 'name'),
        network_connection_id=pulumi.get(__response__, 'network_connection_id')))
